﻿using UnityEngine;
using System.Collections;

public class Rocket : MonoBehaviour
{

    #region members
    public int damagePoints = 15;
    public float speed = 1;
    public float pushForce = 20; //wie stark das target weggeschubst wird beim aufprall.

    private Rigidbody2D body;
    public Transform target;

    #endregion

    // Use this for initialization
    void Start () {
        body = GetComponent<Rigidbody2D>();
    }
    
    // Update is called once per frame
    void Update () {
        if (!target) return;

        //update direction:
        Vector3 direction = target.position - transform.position;
        body.velocity = (float)speed * direction.normalized;
        transform.rotation = Quaternion.Euler(0, 0, -Mathf.Rad2Deg * Mathf.Atan2(direction.x, direction.y));
    }

    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.tag == "Player")
        {
            other.GetComponent<PlayerHealth>().changeHealthBy(-damagePoints);
            Rigidbody2D otherBody = other.GetComponent<Rigidbody2D>();
            Debug.Log(body.velocity.normalized * pushForce);
            otherBody.velocity = Vector2.zero;
            otherBody.AddForce(body.velocity.normalized * pushForce);
            Invoke("destroy", 0.1f);
        }
    }

    void destroy()
    {
        Destroy(gameObject);
    }

    public void setTarget(Transform newTarget)
    {
        target = newTarget;
    }
}
